import java.net.*;
import java.util.Hashtable;

public class TestFactory implements URLStreamHandlerFactory {
    static Hashtable handlers = new Hashtable();

    public URLStreamHandler createURLStreamHandler(String protocol) {
        // try cached handlers first
        URLStreamHandler handler = (URLStreamHandler)handlers.get(protocol);
        if (handler == null) {
            String className = "Test" + protocol + "Handler";
            try {
                handler = (URLStreamHandler)Class.
                    forName(className).newInstance();
            } catch (ClassNotFoundException e) {
                handler = null;                 // not found
            } catch (Exception e) {
                // all other exceptions, print out problem
                e.printStackTrace();
                handler = null;
            }
            
            if (handler != null)
                handlers.put(protocol, handler); // put into cache
        }
        return (handler);
    }
}
